package com.xypower.gpuv.egl.filter;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.Rect;
import android.util.Log;

public class GlWatermarkFilter extends GlOverlayFilter {

    private Object mLocker = new Object();
    private Bitmap bitmap;
    private boolean invalidated = true;
    private Position position = Position.LEFT_TOP;

    public GlWatermarkFilter(Bitmap bitmap) {
        this.bitmap = bitmap;
    }


    public GlWatermarkFilter(Bitmap bitmap, Position position) {
        this.bitmap = bitmap;
        this.position = position;
    }

    public void updateBitmap(Bitmap bm) {
        Bitmap oldBitmap = null;
        synchronized (mLocker) {
            invalidated = true;
            oldBitmap = bitmap;
            bitmap = bm;
        }

        if (oldBitmap != null) {
            // oldBitmap.recycle();
        }
    }

    @Override
    protected void drawCanvas(Canvas canvas) {
        synchronized (mLocker) {
            Log.d("OSD", "drawCanvas");
            if (invalidated) {
                canvas.drawColor(Color.TRANSPARENT, PorterDuff.Mode.CLEAR);
                canvas.drawBitmap(bitmap, null, canvas.getClipBounds(), null);
                invalidated = false;
            }
        }

        /*
        if (bitmap != null && !bitmap.isRecycled()) {
            switch (position) {
                case LEFT_TOP:
                    // canvas.drawBitmap(bitmap, 0, 0, null);
                    canvas.drawBitmap(bitmap, null, canvas.getClipBounds(), null);
                    break;
                case LEFT_BOTTOM:
                    canvas.drawBitmap(bitmap, 0, canvas.getHeight() - bitmap.getHeight(), null);
                    break;
                case RIGHT_TOP:
                    canvas.drawBitmap(bitmap, canvas.getWidth() - bitmap.getWidth(), 0, null);
                    break;
                case RIGHT_BOTTOM:
                    canvas.drawBitmap(bitmap, canvas.getWidth() - bitmap.getWidth(), canvas.getHeight() - bitmap.getHeight(), null);
                    break;
            }
        }

         */
    }

    public enum Position {
        LEFT_TOP,
        LEFT_BOTTOM,
        RIGHT_TOP,
        RIGHT_BOTTOM
    }
}
